﻿#Copyright disclaimer:
#    Copyright (C) 2015,  ITHierarchy Inc (www.ithierarchy.com). ALl rights reserverd.
#    This program is free software: you can redistribute it and/or modify
#        it under the terms of the GNU General Public License as published by
#        the Free Software Foundation, either version 3 of the License, or
#        (at your option) any later version.
#
#        This program is distributed in the hope that it will be useful,
#        but WITHOUT ANY WARRANTY; without even the implied warranty of
#        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#        GNU General Public License for more details.
#
#        You should have received a copy of the GNU General Public License
#        along with this program.  If not, see <http://www.gnu.org/licenses/>.

Param(
  [string]$level

)
$DateStamp=$(((get-date)).ToString("yyyyMMddTHHmmss"))
if ($level -eq "Full"){$Backup="Bacula-*"}Else{$Backup="Bacula-$level*"}


$HyperVPath="C:\Hyper-V"  #Set path to your Hyper-V Machines to be backed up

#Sort out Actual Volume path to VM
$VMDrive=$HyperVPath.Substring(0,1)
$volume=Get-Volume $VMDrive
$TrueHyperVPath=$($HyperVPath.Replace("$($VMDrive):\",$($Volume.path)))

    #Get List of VMs
    $VMs=Get-VM 
        foreach ($VM in $VMs){
        #Check to make sure it is in the Hyper-V Path
        if ($($VM.path).ToUpper() -like ("$TrueHyperVPath\*").ToUpper()) { 
            $vm.Path

            #Snap those VMs
            
            write-host "Starting VM $($vm.Name) @ '$($vm.Path)'"
            $CurrentSnapShots = $VM | Get-VMSnapshot 

            foreach ($SnapShot in $CurrentSnapShots){
                if ($SnapShot.Name -like ("$Backup")){   
                    
                    write-host "Removing VM Checkpoint '$($SnapShot.Name)'"
                    $SnapShot | Remove-VMSnapshot  
                

                    $LoopCount=0
                    do {
                        Write-host "Waiting for snapshot '$($SnapShot.name)' to delete..."
                        
                        Start-Sleep -s 10 
                        $LoopCount=$LoopCount+1
                    }while ($VM.Status -eq "Merging disks" -and $LoopCount -lt 30)
                }
            }
            
            write-host "Creating Checkpoint  Bacula-$level.$DateStamp"
            $VM | Checkpoint-VM -SnapshotName Bacula-$level.$DateStamp
        }
    }

